require '_h2ph_pre.ph';

unless(defined(&_MACHINE_ASMACROS_H_)) {
    eval 'sub _MACHINE_ASMACROS_H_ () {1;}' unless defined(&_MACHINE_ASMACROS_H_);
    require 'sys/cdefs.ph';
    require 'machine/asnames.ph';
    if(defined( &__ELF__)) {
	eval 'sub CNAME {
	    local($csym) = @_;
    	    eval q($csym);
	}' unless defined(&CNAME);
	eval 'sub HIDENAME {
	    local($asmsym) = @_;
    	    eval q( &__CONCAT(.,$asmsym));
	}' unless defined(&HIDENAME);
    } else {
	eval 'sub CNAME {
	    local($csym) = @_;
    	    eval q( &__CONCAT( &_,$csym));
	}' unless defined(&CNAME);
	eval 'sub HIDENAME {
	    local($asmsym) = @_;
    	    eval q($asmsym);
	}' unless defined(&HIDENAME);
    }
    eval 'sub ALIGN_DATA () {. &p2align 2;}' unless defined(&ALIGN_DATA);
    if(defined(&GPROF)) {
	eval 'sub ALIGN_TEXT () {. &p2align 4,0x90;}' unless defined(&ALIGN_TEXT);
    } else {
	eval 'sub ALIGN_TEXT () {. &p2align 2,0x90;}' unless defined(&ALIGN_TEXT);
    }
    eval 'sub SUPERALIGN_TEXT () {. &p2align 4,0x90;}' unless defined(&SUPERALIGN_TEXT);
    eval 'sub GEN_ENTRY {
        local($name) = @_;
	    eval q( &ALIGN_TEXT; . &globl  &CNAME($name);  &CNAME($name):);
    }' unless defined(&GEN_ENTRY);
    eval 'sub NON_GPROF_ENTRY {
        local($name) = @_;
	    eval q( &GEN_ENTRY($name));
    }' unless defined(&NON_GPROF_ENTRY);
    eval 'sub NON_GPROF_RET () {. &byte 0xc3;}' unless defined(&NON_GPROF_RET);
    if(defined(&GPROF)) {
	eval 'sub ALTENTRY {
	    local($name) = @_;
    	    eval q( &GEN_ENTRY($name) ;  &MCOUNT ;  &MEXITCOUNT ;  &jmp 9 &f);
	}' unless defined(&ALTENTRY);
	eval 'sub CROSSJUMP {
	    local($jtrue, $label, $jfalse) = @_;
    	    eval q($jfalse 8 &f;  &MEXITCOUNT;  &jmp  &__CONCAT( &to,$label); 8:);
	}' unless defined(&CROSSJUMP);
	eval 'sub CROSSJUMPTARGET {
	    local($label) = @_;
    	    eval q( &ALIGN_TEXT;  &__CONCAT( &to,$label): ;  &MCOUNT;  &jmp $label);
	}' unless defined(&CROSSJUMPTARGET);
	eval 'sub ENTRY {
	    local($name) = @_;
    	    eval q( &GEN_ENTRY($name) ; 9: ;  &MCOUNT);
	}' unless defined(&ENTRY);
	eval 'sub FAKE_MCOUNT {
	    local($caller) = @_;
    	    eval q( &pushl $caller ;  &call  &__mcount ;  &popl % &ecx);
	}' unless defined(&FAKE_MCOUNT);
	eval 'sub MCOUNT () { &call  &__mcount;}' unless defined(&MCOUNT);
	eval 'sub MCOUNT_LABEL {
	    local($name) = @_;
    	    eval q( &GEN_ENTRY($name) ;  &nop ;  &ALIGN_TEXT);
	}' unless defined(&MCOUNT_LABEL);
	eval 'sub MEXITCOUNT () { &call  &mexitcount;}' unless defined(&MEXITCOUNT);
	eval 'sub ret () { &MEXITCOUNT ;  &NON_GPROF_RET;}' unless defined(&ret);
    } else {
	eval 'sub ALTENTRY {
	    local($name) = @_;
    	    eval q( &GEN_ENTRY($name));
	}' unless defined(&ALTENTRY);
	eval 'sub CROSSJUMP {
	    local($jtrue, $label, $jfalse) = @_;
    	    eval q($jtrue $label);
	}' unless defined(&CROSSJUMP);
	eval 'sub CROSSJUMPTARGET {
	    local($label) = @_;
    	    eval q();
	}' unless defined(&CROSSJUMPTARGET);
	eval 'sub ENTRY {
	    local($name) = @_;
    	    eval q( &GEN_ENTRY($name));
	}' unless defined(&ENTRY);
	eval 'sub FAKE_MCOUNT {
	    local($caller) = @_;
    	    eval q();
	}' unless defined(&FAKE_MCOUNT);
	eval 'sub MCOUNT () {1;}' unless defined(&MCOUNT);
	eval 'sub MCOUNT_LABEL {
	    local($name) = @_;
    	    eval q();
	}' unless defined(&MCOUNT_LABEL);
	eval 'sub MEXITCOUNT () {1;}' unless defined(&MEXITCOUNT);
    }
}
1;
