require '_h2ph_pre.ph';

unless(defined(&_MACHINE_LOCK_H_)) {
    eval 'sub _MACHINE_LOCK_H_ () {1;}' unless defined(&_MACHINE_LOCK_H_);
    if(defined(&LOCORE)) {
	if(defined(&SMP)) {
	    eval 'sub MPLOCKED () { &lock ;;}' unless defined(&MPLOCKED);
	    eval 'sub FPU_LOCK () { &call  &_get_fpu_lock;}' unless defined(&FPU_LOCK);
	    eval 'sub ALIGN_LOCK () { &call  &_get_align_lock;}' unless defined(&ALIGN_LOCK);
	    eval 'sub SYSCALL_LOCK () { &call  &_get_syscall_lock;}' unless defined(&SYSCALL_LOCK);
	    eval 'sub ALTSYSCALL_LOCK () { &call  &_get_altsyscall_lock;}' unless defined(&ALTSYSCALL_LOCK);
	    eval 'sub ISR_TRYLOCK () { &pushl $ &_mp_lock ;  &call  &_MPtrylock ;  &add $4, % &esp;}' unless defined(&ISR_TRYLOCK);
	    eval 'sub ISR_RELLOCK () { &pushl $ &_mp_lock ;  &call  &_MPrellock ;  &add $4, % &esp;}' unless defined(&ISR_RELLOCK);
	    eval 'sub IMASK_LOCK () { &pushl $ &_imen_lock ;  &call  &_s_lock ;  &addl $4, % &esp;}' unless defined(&IMASK_LOCK);
	    eval 'sub IMASK_UNLOCK () { &pushl $ &_imen_lock ;  &call  &_s_unlock ;  &addl $4, % &esp;}' unless defined(&IMASK_UNLOCK);
	    eval 'sub CPL_LOCK () { &pushl $ &_cpl_lock ;  &call  &_s_lock ;  &addl $4, % &esp;}' unless defined(&CPL_LOCK);
	    eval 'sub CPL_UNLOCK () { &pushl $ &_cpl_lock ;  &call  &_s_unlock ;  &addl $4, % &esp;}' unless defined(&CPL_UNLOCK);
	    eval 'sub SCPL_LOCK () { &pushl $ &_cpl_lock ;  &call  &_ss_lock ;  &addl $4, % &esp;}' unless defined(&SCPL_LOCK);
	    eval 'sub SCPL_UNLOCK () { &pushl $ &_cpl_lock ;  &call  &_ss_unlock ;  &addl $4, % &esp;}' unless defined(&SCPL_UNLOCK);
	} else {
	    eval 'sub MPLOCKED () {1;}' unless defined(&MPLOCKED);
	    eval 'sub FPU_LOCK () {1;}' unless defined(&FPU_LOCK);
	    eval 'sub ALIGN_LOCK () {1;}' unless defined(&ALIGN_LOCK);
	    eval 'sub SYSCALL_LOCK () {1;}' unless defined(&SYSCALL_LOCK);
	    eval 'sub ALTSYSCALL_LOCK () {1;}' unless defined(&ALTSYSCALL_LOCK);
	}
    } else {
	if(defined(&SMP)) {
	    require 'machine/smptests.ph';
	    if(defined(&USE_MPINTRLOCK)) {
		eval 'sub MPINTR_LOCK () {
		    eval q( &s_lock( &mpintr_lock));
		}' unless defined(&MPINTR_LOCK);
		eval 'sub MPINTR_UNLOCK () {
		    eval q( &s_unlock( &mpintr_lock));
		}' unless defined(&MPINTR_UNLOCK);
	    } else {
		eval 'sub MPINTR_LOCK () {
		    eval q();
		}' unless defined(&MPINTR_LOCK);
		eval 'sub MPINTR_UNLOCK () {
		    eval q();
		}' unless defined(&MPINTR_UNLOCK);
	    }
	    eval 'sub CPL_LOCK () {
	        eval q( &s_lock( &cpl_lock));
	    }' unless defined(&CPL_LOCK);
	    eval 'sub CPL_UNLOCK () {
	        eval q( &s_unlock( &cpl_lock));
	    }' unless defined(&CPL_UNLOCK);
	    eval 'sub SCPL_LOCK () {
	        eval q( &ss_lock( &cpl_lock));
	    }' unless defined(&SCPL_LOCK);
	    eval 'sub SCPL_UNLOCK () {
	        eval q( &ss_unlock( &cpl_lock));
	    }' unless defined(&SCPL_UNLOCK);
	    if(defined(&USE_COMLOCK)) {
		eval 'sub COM_LOCK () {
		    eval q( &s_lock( &com_lock));
		}' unless defined(&COM_LOCK);
		eval 'sub COM_UNLOCK () {
		    eval q( &s_unlock( &com_lock));
		}' unless defined(&COM_UNLOCK);
		eval 'sub COM_DISABLE_INTR () {
		    eval q({  &__asm  &__volatile(\\"cli\\" : : : \\"memory\\");  &COM_LOCK(); });
		}' unless defined(&COM_DISABLE_INTR);
		eval 'sub COM_ENABLE_INTR () {
		    eval q({  &COM_UNLOCK();  &__asm  &__volatile(\\"sti\\"); });
		}' unless defined(&COM_ENABLE_INTR);
	    } else {
		eval 'sub COM_LOCK () {
		    eval q();
		}' unless defined(&COM_LOCK);
		eval 'sub COM_UNLOCK () {
		    eval q();
		}' unless defined(&COM_UNLOCK);
		eval 'sub COM_DISABLE_INTR () {
		    eval q( &disable_intr());
		}' unless defined(&COM_DISABLE_INTR);
		eval 'sub COM_ENABLE_INTR () {
		    eval q( &enable_intr());
		}' unless defined(&COM_ENABLE_INTR);
	    }
	    if(defined(&USE_CLOCKLOCK)) {
		eval 'sub CLOCK_LOCK () {
		    eval q( &s_lock( &clock_lock));
		}' unless defined(&CLOCK_LOCK);
		eval 'sub CLOCK_UNLOCK () {
		    eval q( &s_unlock( &clock_lock));
		}' unless defined(&CLOCK_UNLOCK);
		eval 'sub CLOCK_DISABLE_INTR () {
		    eval q({  &__asm  &__volatile(\\"cli\\" : : : \\"memory\\");  &CLOCK_LOCK(); });
		}' unless defined(&CLOCK_DISABLE_INTR);
		eval 'sub CLOCK_ENABLE_INTR () {
		    eval q({  &CLOCK_UNLOCK();  &__asm  &__volatile(\\"sti\\"); });
		}' unless defined(&CLOCK_ENABLE_INTR);
	    } else {
		eval 'sub CLOCK_LOCK () {
		    eval q();
		}' unless defined(&CLOCK_LOCK);
		eval 'sub CLOCK_UNLOCK () {
		    eval q();
		}' unless defined(&CLOCK_UNLOCK);
		eval 'sub CLOCK_DISABLE_INTR () {
		    eval q( &disable_intr());
		}' unless defined(&CLOCK_DISABLE_INTR);
		eval 'sub CLOCK_ENABLE_INTR () {
		    eval q( &enable_intr());
		}' unless defined(&CLOCK_ENABLE_INTR);
	    }
	} else {
	    eval 'sub MPINTR_LOCK () {
	        eval q();
	    }' unless defined(&MPINTR_LOCK);
	    eval 'sub MPINTR_UNLOCK () {
	        eval q();
	    }' unless defined(&MPINTR_UNLOCK);
	    eval 'sub CPL_LOCK () {
	        eval q();
	    }' unless defined(&CPL_LOCK);
	    eval 'sub CPL_UNLOCK () {
	        eval q();
	    }' unless defined(&CPL_UNLOCK);
	    eval 'sub SCPL_LOCK () {
	        eval q();
	    }' unless defined(&SCPL_LOCK);
	    eval 'sub SCPL_UNLOCK () {
	        eval q();
	    }' unless defined(&SCPL_UNLOCK);
	    eval 'sub COM_LOCK () {
	        eval q();
	    }' unless defined(&COM_LOCK);
	    eval 'sub COM_UNLOCK () {
	        eval q();
	    }' unless defined(&COM_UNLOCK);
	    eval 'sub CLOCK_LOCK () {
	        eval q();
	    }' unless defined(&CLOCK_LOCK);
	    eval 'sub CLOCK_UNLOCK () {
	        eval q();
	    }' unless defined(&CLOCK_UNLOCK);
	}
	if(!defined( &SIMPLELOCK_DEBUG)  && (defined(&NCPUS) ? &NCPUS : 0) > 1) {
	    eval 'sub simple_lock_init {
	        local($alp) = @_;
    		eval q( &s_lock_init($alp));
	    }' unless defined(&simple_lock_init);
	    eval 'sub simple_lock {
	        local($alp) = @_;
    		eval q( &s_lock($alp));
	    }' unless defined(&simple_lock);
	    eval 'sub simple_lock_try {
	        local($alp) = @_;
    		eval q( &s_lock_try($alp));
	    }' unless defined(&simple_lock_try);
	    eval 'sub simple_unlock {
	        local($alp) = @_;
    		eval q( &s_unlock($alp));
	    }' unless defined(&simple_unlock);
	}
    }
}
1;
