require '_h2ph_pre.ph';

require 'sys/callout.ph';
unless(defined(&SI_MAXPORTPERCARD)) {
    sub SI_MAXPORTPERCARD () {	32;}
}
unless(defined(&SI_MAXCONTROLLER)) {
    sub SI_MAXCONTROLLER () {	4;}
}
unless(defined(&SI_PORT_MASK)) {
    sub SI_PORT_MASK () {	0x1f;}
}
unless(defined(&SI_CARD_MASK)) {
    sub SI_CARD_MASK () {	0x60;}
}
unless(defined(&SI_TTY_MASK)) {
    sub SI_TTY_MASK () {	0x7f;}
}
unless(defined(&SI_CALLOUT_MASK)) {
    sub SI_CALLOUT_MASK () {	0x80;}
}
unless(defined(&SI_INIT_STATE_MASK)) {
    sub SI_INIT_STATE_MASK () {	0x10000;}
}
unless(defined(&SI_LOCK_STATE_MASK)) {
    sub SI_LOCK_STATE_MASK () {	0x20000;}
}
unless(defined(&SI_STATE_MASK)) {
    sub SI_STATE_MASK () {	0x30000;}
}
unless(defined(&SI_CONTROLDEV_MASK)) {
    sub SI_CONTROLDEV_MASK () {	0x40000;}
}
unless(defined(&SI_SPECIAL_MASK)) {
    sub SI_SPECIAL_MASK () {	0x70000;}
}
unless(defined(&SI_CARDSHIFT)) {
    sub SI_CARDSHIFT () {	5;}
}
unless(defined(&SI_PORT)) {
    sub SI_PORT {
	local($m) = @_;
	eval q(($m &  &SI_PORT_MASK));
    }
}
unless(defined(&SI_CARD)) {
    sub SI_CARD {
	local($m) = @_;
	eval q((($m &  &SI_CARD_MASK) >>  &SI_CARDSHIFT));
    }
}
unless(defined(&SI_TTY)) {
    sub SI_TTY {
	local($m) = @_;
	eval q(($m &  &SI_TTY_MASK));
    }
}
unless(defined(&IS_CALLOUT)) {
    sub IS_CALLOUT {
	local($m) = @_;
	eval q(($m &  &SI_CALLOUT_MASK));
    }
}
unless(defined(&IS_STATE)) {
    sub IS_STATE {
	local($m) = @_;
	eval q(($m &  &SI_STATE_MASK));
    }
}
unless(defined(&IS_CONTROLDEV)) {
    sub IS_CONTROLDEV {
	local($m) = @_;
	eval q(($m &  &SI_CONTROLDEV_MASK));
    }
}
unless(defined(&IS_SPECIAL)) {
    sub IS_SPECIAL {
	local($m) = @_;
	eval q(($m &  &SI_SPECIAL_MASK));
    }
}
unless(defined(&MINOR2SC)) {
    sub MINOR2SC {
	local($m) = @_;
	eval q(( $si_softc[ &SI_CARD($m)]));
    }
}
unless(defined(&MINOR2PP)) {
    sub MINOR2PP {
	local($m) = @_;
	eval q(( &MINOR2SC(($m))-> &sc_ports +  &SI_PORT(($m))));
    }
}
unless(defined(&MINOR2TP)) {
    sub MINOR2TP {
	local($m) = @_;
	eval q(( &MINOR2PP(($m))-> &sp_tty));
    }
}
unless(defined(&TP2PP)) {
    sub TP2PP {
	local($tp) = @_;
	eval q(( &MINOR2PP( &SI_TTY( &minor(($tp)-> &t_dev)))));
    }
}
unless(defined(&SIEMPTY)) {
    sub SIEMPTY () {	0;}
}
unless(defined(&SIHOST)) {
    sub SIHOST () {	1;}
}
unless(defined(&SIMCA)) {
    sub SIMCA () {	2;}
}
unless(defined(&SIHOST2)) {
    sub SIHOST2 () {	3;}
}
unless(defined(&SIEISA)) {
    sub SIEISA () {	4;}
}
unless(defined(&SIPCI)) {
    sub SIPCI () {	5;}
}
unless(defined(&SIJETPCI)) {
    sub SIJETPCI () {	6;}
}
unless(defined(&SIJETISA)) {
    sub SIJETISA () {	7;}
}
unless(defined(&SI_ISJET)) {
    sub SI_ISJET {
	local($x) = @_;
	eval q(((($x) ==  &SIJETPCI) || (($x) ==  &SIJETISA)));
    }
}
unless(defined(&SI_BUFFERSIZE)) {
    sub SI_BUFFERSIZE () {	256;}
}
unless(defined(&TA4)) {
    sub TA4 () {	0x00;}
}
unless(defined(&TA8)) {
    sub TA8 () {	0x08;}
}
unless(defined(&TA4_ASIC)) {
    sub TA4_ASIC () {	0x0a;}
}
unless(defined(&TA8_ASIC)) {
    sub TA8_ASIC () {	0x0b;}
}
unless(defined(&MTA)) {
    sub MTA () {	0x28;}
}
unless(defined(&SXDC)) {
    sub SXDC () {	0x48;}
}
unless(defined(&BR_IGN)) {
    sub BR_IGN () {	0x01;}
}
unless(defined(&BR_INT)) {
    sub BR_INT () {	0x02;}
}
unless(defined(&BR_PARMRK)) {
    sub BR_PARMRK () {	0x04;}
}
unless(defined(&BR_PARIGN)) {
    sub BR_PARIGN () {	0x08;}
}
unless(defined(&SP_TANY)) {
    sub SP_TANY () {	0x01;}
}
unless(defined(&SP_TXEN)) {
    sub SP_TXEN () {	0x02;}
}
unless(defined(&SP_CEN)) {
    sub SP_CEN () {	0x04;}
}
unless(defined(&SP_RXEN)) {
    sub SP_RXEN () {	0x08;}
}
unless(defined(&SP_DCEN)) {
    sub SP_DCEN () {	0x20;}
}
unless(defined(&SP_PAEN)) {
    sub SP_PAEN () {	0x80;}
}
unless(defined(&IDLE_OPEN)) {
    sub IDLE_OPEN () {	0x00;}
}
unless(defined(&LOPEN)) {
    sub LOPEN () {	0x02;}
}
unless(defined(&MOPEN)) {
    sub MOPEN () {	0x04;}
}
unless(defined(&MPEND)) {
    sub MPEND () {	0x06;}
}
unless(defined(&CONFIG)) {
    sub CONFIG () {	0x08;}
}
unless(defined(&CLOSE)) {
    sub CLOSE () {	0x0a;}
}
unless(defined(&SBREAK)) {
    sub SBREAK () {	0x0c;}
}
unless(defined(&EBREAK)) {
    sub EBREAK () {	0x0e;}
}
unless(defined(&IDLE_CLOSE)) {
    sub IDLE_CLOSE () {	0x10;}
}
unless(defined(&IDLE_BREAK)) {
    sub IDLE_BREAK () {	0x12;}
}
unless(defined(&FCLOSE)) {
    sub FCLOSE () {	0x14;}
}
unless(defined(&RESUME)) {
    sub RESUME () {	0x16;}
}
unless(defined(&WFLUSH)) {
    sub WFLUSH () {	0x18;}
}
unless(defined(&RFLUSH)) {
    sub RFLUSH () {	0x1a;}
}
unless(defined(&ST_BREAK)) {
    sub ST_BREAK () {	0x01;}
}
unless(defined(&OP_CTS)) {
    sub OP_CTS () {	0x01;}
}
unless(defined(&OP_DSR)) {
    sub OP_DSR () {	0x02;}
}
unless(defined(&IP_DCD)) {
    sub IP_DCD () {	0x04;}
}
unless(defined(&IP_DTR)) {
    sub IP_DTR () {	0x20;}
}
unless(defined(&IP_RTS)) {
    sub IP_RTS () {	0x02;}
}
unless(defined(&IP_RI)) {
    sub IP_RI () {	0x40;}
}
unless(defined(&MR1_5_BITS)) {
    sub MR1_5_BITS () {	0x00;}
}
unless(defined(&MR1_6_BITS)) {
    sub MR1_6_BITS () {	0x01;}
}
unless(defined(&MR1_7_BITS)) {
    sub MR1_7_BITS () {	0x02;}
}
unless(defined(&MR1_8_BITS)) {
    sub MR1_8_BITS () {	0x03;}
}
unless(defined(&MR1_ODD)) {
    sub MR1_ODD () {	0x04;}
}
unless(defined(&MR1_EVEN)) {
    sub MR1_EVEN () {	0x00;}
}
unless(defined(&MR1_WITH)) {
    sub MR1_WITH () {	0x00;}
}
unless(defined(&MR1_FORCE)) {
    sub MR1_FORCE () {	0x08;}
}
unless(defined(&MR1_NONE)) {
    sub MR1_NONE () {	0x10;}
}
unless(defined(&MR1_SPECIAL)) {
    sub MR1_SPECIAL () {	0x18;}
}
unless(defined(&MR1_CHAR)) {
    sub MR1_CHAR () {	0x00;}
}
unless(defined(&MR1_BLOCK)) {
    sub MR1_BLOCK () {	0x20;}
}
unless(defined(&MR1_CTSCONT)) {
    sub MR1_CTSCONT () {	0x80;}
}
unless(defined(&MR2_1_STOP)) {
    sub MR2_1_STOP () {	0x07;}
}
unless(defined(&MR2_2_STOP)) {
    sub MR2_2_STOP () {	0x0f;}
}
unless(defined(&MR2_RTSCONT)) {
    sub MR2_RTSCONT () {	0x10;}
}
unless(defined(&MR2_CTSCONT)) {
    sub MR2_CTSCONT () {	0x20;}
}
unless(defined(&MR2_NORMAL)) {
    sub MR2_NORMAL () {	0x00;}
}
unless(defined(&MR2_AUTO)) {
    sub MR2_AUTO () {	0x40;}
}
unless(defined(&MR2_LOCAL)) {
    sub MR2_LOCAL () {	0x80;}
}
unless(defined(&MR2_REMOTE)) {
    sub MR2_REMOTE () {	0xc0;}
}
unless(defined(&CLK75)) {
    sub CLK75 () {	0x0;}
}
unless(defined(&CLK110)) {
    sub CLK110 () {	0x1;}
}
unless(defined(&CLK38400)) {
    sub CLK38400 () {	0x2;}
}
unless(defined(&CLK150)) {
    sub CLK150 () {	0x3;}
}
unless(defined(&CLK300)) {
    sub CLK300 () {	0x4;}
}
unless(defined(&CLK600)) {
    sub CLK600 () {	0x5;}
}
unless(defined(&CLK1200)) {
    sub CLK1200 () {	0x6;}
}
unless(defined(&CLK2000)) {
    sub CLK2000 () {	0x7;}
}
unless(defined(&CLK2400)) {
    sub CLK2400 () {	0x8;}
}
unless(defined(&CLK4800)) {
    sub CLK4800 () {	0x9;}
}
unless(defined(&CLK7200)) {
    sub CLK7200 () {	0xa;}
}
unless(defined(&CLK9600)) {
    sub CLK9600 () {	0xb;}
}
unless(defined(&CLK19200)) {
    sub CLK19200 () {	0xc;}
}
unless(defined(&CLK57600)) {
    sub CLK57600 () {	0xd;}
}
if(defined(&SI_DEBUG)) {
}
unless(defined(&SS_CLOSED)) {
    sub SS_CLOSED () {	0x0000;}
}
unless(defined(&SS_OPEN)) {
    sub SS_OPEN () {	0x0001;}
}
unless(defined(&SS_LSTART)) {
    sub SS_LSTART () {	0x0100;}
}
unless(defined(&SS_INLSTART)) {
    sub SS_INLSTART () {	0x0200;}
}
unless(defined(&SS_CLOSING)) {
    sub SS_CLOSING () {	0x0400;}
}
unless(defined(&SS_WAITWRITE)) {
    sub SS_WAITWRITE () {	0x1000;}
}
unless(defined(&SS_BLOCKWRITE)) {
    sub SS_BLOCKWRITE () {	0x2000;}
}
unless(defined(&SS_DTR_OFF)) {
    sub SS_DTR_OFF () {	0x4000;}
}
unless(defined(&SI_NOWAIT)) {
    sub SI_NOWAIT () {	0x00;}
}
unless(defined(&SI_WAIT)) {
    sub SI_WAIT () {	0x01;}
}
unless(defined(&DBG_ENTRY)) {
    sub DBG_ENTRY () {	0x00000001;}
}
unless(defined(&DBG_DRAIN)) {
    sub DBG_DRAIN () {	0x00000002;}
}
unless(defined(&DBG_OPEN)) {
    sub DBG_OPEN () {	0x00000004;}
}
unless(defined(&DBG_CLOSE)) {
    sub DBG_CLOSE () {	0x00000008;}
}
unless(defined(&DBG_READ)) {
    sub DBG_READ () {	0x00000010;}
}
unless(defined(&DBG_WRITE)) {
    sub DBG_WRITE () {	0x00000020;}
}
unless(defined(&DBG_PARAM)) {
    sub DBG_PARAM () {	0x00000040;}
}
unless(defined(&DBG_INTR)) {
    sub DBG_INTR () {	0x00000080;}
}
unless(defined(&DBG_IOCTL)) {
    sub DBG_IOCTL () {	0x00000100;}
}
unless(defined(&DBG_SELECT)) {
    sub DBG_SELECT () {	0x00000400;}
}
unless(defined(&DBG_OPTIM)) {
    sub DBG_OPTIM () {	0x00000800;}
}
unless(defined(&DBG_START)) {
    sub DBG_START () {	0x00001000;}
}
unless(defined(&DBG_EXIT)) {
    sub DBG_EXIT () {	0x00002000;}
}
unless(defined(&DBG_FAIL)) {
    sub DBG_FAIL () {	0x00004000;}
}
unless(defined(&DBG_STOP)) {
    sub DBG_STOP () {	0x00008000;}
}
unless(defined(&DBG_AUTOBOOT)) {
    sub DBG_AUTOBOOT () {	0x00010000;}
}
unless(defined(&DBG_MODEM)) {
    sub DBG_MODEM () {	0x00020000;}
}
unless(defined(&DBG_DOWNLOAD)) {
    sub DBG_DOWNLOAD () {	0x00040000;}
}
unless(defined(&DBG_LSTART)) {
    sub DBG_LSTART () {	0x00080000;}
}
unless(defined(&DBG_POLL)) {
    sub DBG_POLL () {	0x00100000;}
}
unless(defined(&DBG_ALL)) {
    sub DBG_ALL () {	0xffffffff;}
}
unless(defined(&tc_card)) {
    sub tc_card () {	 ($tc_dev->{sid_card});}
}
unless(defined(&tc_port)) {
    sub tc_port () {	 ($tc_dev->{sid_port});}
}
unless(defined(&tc_int)) {
    sub tc_int () {	 ($tc_action->{x_int});}
}
unless(defined(&tc_dbglvl)) {
    sub tc_dbglvl () {	 ($tc_action->{x_dbglvl});}
}
unless(defined(&tc_siport)) {
    sub tc_siport () {	 ($tc_action->{x_siport});}
}
unless(defined(&tc_ccb)) {
    sub tc_ccb () {	 ($tc_action->{x_ccb});}
}
unless(defined(&tc_tty)) {
    sub tc_tty () {	 ($tc_action->{x_tty});}
}
unless(defined(&IOCTL_MIN)) {
    sub IOCTL_MIN () {	96;}
}
unless(defined(&TCSIDEBUG)) {
    sub TCSIDEBUG () {	 &_IOW(ord('S'), 96, 'struct si_tcsi');}
}
unless(defined(&TCSIRXIT)) {
    sub TCSIRXIT () {	 &_IOW(ord('S'), 97, 'struct si_tcsi');}
}
unless(defined(&TCSIIT)) {
    sub TCSIIT () {	 &_IOW(ord('S'), 98, 'struct si_tcsi');}
}
unless(defined(&TCSISTATE)) {
    sub TCSISTATE () {	 &_IOWR(ord('S'), 105, 'struct si_tcsi');}
}
unless(defined(&TCSIPORTS)) {
    sub TCSIPORTS () {	 &_IOR(ord('S'), 107, 'int');}
}
unless(defined(&TCSISDBG_LEVEL)) {
    sub TCSISDBG_LEVEL () {	 &_IOW(ord('S'), 108, 'struct si_tcsi');}
}
unless(defined(&TCSIGDBG_LEVEL)) {
    sub TCSIGDBG_LEVEL () {	 &_IOWR(ord('S'), 109, 'struct si_tcsi');}
}
unless(defined(&TCSIGRXIT)) {
    sub TCSIGRXIT () {	 &_IOWR(ord('S'), 110, 'struct si_tcsi');}
}
unless(defined(&TCSIGIT)) {
    sub TCSIGIT () {	 &_IOWR(ord('S'), 111, 'struct si_tcsi');}
}
unless(defined(&TCSISDBG_ALL)) {
    sub TCSISDBG_ALL () {	 &_IOW(ord('S'), 118, 'int');}
}
unless(defined(&TCSIGDBG_ALL)) {
    sub TCSIGDBG_ALL () {	 &_IOR(ord('S'), 119, 'int');}
}
unless(defined(&TCSIMODULES)) {
    sub TCSIMODULES () {	 &_IOR(ord('S'), 124, 'int');}
}
unless(defined(&TCSI_PORT)) {
    sub TCSI_PORT () {	 &_IOWR(ord('S'), 125, 'struct si_pstat');}
}
unless(defined(&TCSI_CCB)) {
    sub TCSI_CCB () {	 &_IOWR(ord('S'), 126, 'struct si_pstat');}
}
unless(defined(&TCSI_TTY)) {
    sub TCSI_TTY () {	 &_IOWR(ord('S'), 127, 'struct si_pstat');}
}
unless(defined(&IOCTL_MAX)) {
    sub IOCTL_MAX () {	127;}
}
unless(defined(&IS_SI_IOCTL)) {
    sub IS_SI_IOCTL {
	local($cmd) = @_;
	eval q(((&0xff00) == (ord('S')<<8)  && (&0xff) >=  &IOCTL_MIN  && (($cmd)&0xff) <=  &IOCTL_MAX));
    }
}
unless(defined(&CONTROLDEV)) {
    sub CONTROLDEV () {	"/dev/si_control";}
}
1;
