require '_h2ph_pre.ph';

unless(defined(&__IP_COMPAT_H__)) {
    eval 'sub __IP_COMPAT_H__ () {1;}' unless defined(&__IP_COMPAT_H__);
    unless(defined(&__P)) {
	if(defined(&__STDC__)) {
	    eval 'sub __P {
	        local($x) = @_;
    		eval q($x);
	    }' unless defined(&__P);
	} else {
	    eval 'sub __P {
	        local($x) = @_;
    		eval q(());
	    }' unless defined(&__P);
	    eval 'sub const () {1;}' unless defined(&const);
	}
    }
    unless(defined(&SOLARIS)) {
	eval 'sub SOLARIS () {(defined( &sun)  && (defined( &__svr4__) || defined( &__SVR4)));}' unless defined(&SOLARIS);
    }
    if(defined( &_KERNEL)  && !defined( &KERNEL)) {
	eval 'sub KERNEL () {1;}' unless defined(&KERNEL);
    }
    if(defined( &KERNEL)  && !defined( &_KERNEL)) {
	eval 'sub _KERNEL () {1;}' unless defined(&_KERNEL);
    }
    eval 'sub __KERNEL__ () {1;}' unless defined(&__KERNEL__);
}
if(defined( &__SVR4) || defined( &__svr4__) || defined( &__sgi)) {
    eval 'sub index () { &strchr;}' unless defined(&index);
    if(!defined( &_KERNEL)) {
	eval 'sub bzero {
	    local($a,$b) = @_;
    	    eval q( &memset($a,0,$b));
	}' unless defined(&bzero);
	eval 'sub bcmp () { &memcmp;}' unless defined(&bcmp);
	eval 'sub bcopy {
	    local($a,$b,$c) = @_;
    	    eval q( &memmove($b,$a,$c));
	}' unless defined(&bcopy);
    }
}
if(defined( &__sgi) || defined( &bsdi)) {
}
if(defined( &__sgi)  && !defined( &IPFILTER_LKM)) {
    if(defined(&__STDC__)) {
	eval 'sub IPL_EXTERN {
	    local($ep) = @_;
    	    eval q( &ipfilter$ep);
	}' unless defined(&IPL_EXTERN);
    } else {
	eval 'sub IPL_EXTERN {
	    local($ep) = @_;
    	    eval q( &ipfilterep);
	}' unless defined(&IPL_EXTERN);
    }
} else {
    if(defined(&__STDC__)) {
	eval 'sub IPL_EXTERN {
	    local($ep) = @_;
    	    eval q( &ipl$ep);
	}' unless defined(&IPL_EXTERN);
    } else {
	eval 'sub IPL_EXTERN {
	    local($ep) = @_;
    	    eval q( &iplep);
	}' unless defined(&IPL_EXTERN);
    }
}
if(defined(&linux)) {
    require 'sys/sysmacros.ph';
}
if((defined(&SOLARIS) ? &SOLARIS : 0)) {
    eval 'sub MTYPE {
        local($m) = @_;
	    eval q((($m)-> ($b_datap->{db_type})));
    }' unless defined(&MTYPE);
    require 'sys/ioccom.ph';
    require 'sys/sysmacros.ph';
    require 'sys/kmem.ph';
    undef(&IPOPT_EOL) if defined(&IPOPT_EOL);
    undef(&IPOPT_NOP) if defined(&IPOPT_NOP);
    undef(&IPOPT_LSRR) if defined(&IPOPT_LSRR);
    undef(&IPOPT_RR) if defined(&IPOPT_RR);
    undef(&IPOPT_SSRR) if defined(&IPOPT_SSRR);
    unless(defined(&_KERNEL)) {
	eval 'sub _KERNEL () {1;}' unless defined(&_KERNEL);
	undef(&RES_INIT) if defined(&RES_INIT);
	require 'inet/common.ph';
	require 'inet/ip.ph';
	require 'inet/ip_ire.ph';
	undef(&_KERNEL) if defined(&_KERNEL);
    } else {
	require 'inet/common.ph';
	require 'inet/ip.ph';
	require 'inet/ip_ire.ph';
    }
}
unless(defined(&IPMINLEN)) {
    sub IPMINLEN {
	local($i, $h) = @_;
	eval q((($i)-> &ip_len >= (($i)-> &ip_hl * 4+ $sizeof{'struct h'})));
    }
}
unless(defined(&IP_OFFMASK)) {
    eval 'sub IP_OFFMASK () {0x1fff;}' unless defined(&IP_OFFMASK);
}
if((defined(&BSD) ? &BSD : 0) > 199306) {
    eval 'sub USE_QUAD_T () {1;}' unless defined(&USE_QUAD_T);
    eval 'sub U_QUAD_T () { &u_quad_t;}' unless defined(&U_QUAD_T);
    eval 'sub QUAD_T () { &quad_t;}' unless defined(&QUAD_T);
} else {
    eval 'sub U_QUAD_T () {\'u_long\';}' unless defined(&U_QUAD_T);
    eval 'sub QUAD_T () {\'long\';}' unless defined(&QUAD_T);
}
if(defined( &__NetBSD__) || defined( &__OpenBSD__) || defined( &__FreeBSD__) || defined( &__sgi)) {
} else {
    if(defined( &__alpha__) || defined( &__alpha)) {
    } else {
    }
}
unless(defined(&MAX)) {
    eval 'sub MAX {
        local($a,$b) = @_;
	    eval q(((($a) > ($b)) ? ($a) : ($b)));
    }' unless defined(&MAX);
}
unless(defined(&IPSO_CLASS_RES4)) {
    sub IPSO_CLASS_RES4 () {	0x01;}
}
unless(defined(&IPSO_CLASS_TOPS)) {
    sub IPSO_CLASS_TOPS () {	0x3d;}
}
unless(defined(&IPSO_CLASS_SECR)) {
    sub IPSO_CLASS_SECR () {	0x5a;}
}
unless(defined(&IPSO_CLASS_CONF)) {
    sub IPSO_CLASS_CONF () {	0x96;}
}
unless(defined(&IPSO_CLASS_RES3)) {
    sub IPSO_CLASS_RES3 () {	0x66;}
}
unless(defined(&IPSO_CLASS_RES2)) {
    sub IPSO_CLASS_RES2 () {	0xcc;}
}
unless(defined(&IPSO_CLASS_UNCL)) {
    sub IPSO_CLASS_UNCL () {	0xab;}
}
unless(defined(&IPSO_CLASS_RES1)) {
    sub IPSO_CLASS_RES1 () {	0xf1;}
}
unless(defined(&IPSO_AUTH_GENSER)) {
    sub IPSO_AUTH_GENSER () {	0x80;}
}
unless(defined(&IPSO_AUTH_ESI)) {
    sub IPSO_AUTH_ESI () {	0x40;}
}
unless(defined(&IPSO_AUTH_SCI)) {
    sub IPSO_AUTH_SCI () {	0x20;}
}
unless(defined(&IPSO_AUTH_NSA)) {
    sub IPSO_AUTH_NSA () {	0x10;}
}
unless(defined(&IPSO_AUTH_DOE)) {
    sub IPSO_AUTH_DOE () {	0x08;}
}
unless(defined(&IPSO_AUTH_UN)) {
    sub IPSO_AUTH_UN () {	0x06;}
}
unless(defined(&IPSO_AUTH_FTE)) {
    sub IPSO_AUTH_FTE () {	0x01;}
}
unless(defined(&IPOPT_ZSU)) {
    sub IPOPT_ZSU () {	10;}
}
unless(defined(&IPOPT_MTUP)) {
    sub IPOPT_MTUP () {	11;}
}
unless(defined(&IPOPT_MTUR)) {
    sub IPOPT_MTUR () {	12;}
}
unless(defined(&IPOPT_ENCODE)) {
    sub IPOPT_ENCODE () {	15;}
}
unless(defined(&IPOPT_TR)) {
    sub IPOPT_TR () {	82;}
}
unless(defined(&IPOPT_E_SEC)) {
    sub IPOPT_E_SEC () {	133;}
}
unless(defined(&IPOPT_CIPSO)) {
    sub IPOPT_CIPSO () {	134;}
}
unless(defined(&IPOPT_SID)) {
    eval 'sub IPOPT_SID () { &IPOPT_SATID;}' unless defined(&IPOPT_SID);
}
unless(defined(&IPOPT_ADDEXT)) {
    sub IPOPT_ADDEXT () {	147;}
}
unless(defined(&IPOPT_VISA)) {
    sub IPOPT_VISA () {	142;}
}
unless(defined(&IPOPT_IMITD)) {
    sub IPOPT_IMITD () {	144;}
}
unless(defined(&IPOPT_EIP)) {
    sub IPOPT_EIP () {	145;}
}
unless(defined(&IPOPT_FINN)) {
    sub IPOPT_FINN () {	205;}
}
if(defined( &__FreeBSD__)  && defined( &KERNEL)) {
    if((defined(&__FreeBSD__) ? &__FreeBSD__ : 0) < 3) {
	require 'machine/spl.ph';
    }
    if(defined( &IPFILTER_LKM)  && !defined( &ACTUALLY_LKM_NOT_KERNEL)) {
	eval 'sub ACTUALLY_LKM_NOT_KERNEL () {1;}' unless defined(&ACTUALLY_LKM_NOT_KERNEL);
    }
}
if(defined(&KERNEL)) {
    if((defined(&SOLARIS) ? &SOLARIS : 0)) {
	eval 'sub MUTEX_ENTER {
	    local($x) = @_;
    	    eval q( &mutex_enter($x));
	}' unless defined(&MUTEX_ENTER);
	eval 'sub MUTEX_EXIT {
	    local($x) = @_;
    	    eval q( &mutex_exit($x));
	}' unless defined(&MUTEX_EXIT);
	eval 'sub MTOD {
	    local($m,$t) = @_;
    	    eval q((($m)-> &b_rptr));
	}' unless defined(&MTOD);
	eval 'sub IRCOPY {
	    local($a,$b,$c) = @_;
    	    eval q( &copyin(($a), ($b), ($c)));
	}' unless defined(&IRCOPY);
	eval 'sub IWCOPY {
	    local($a,$b,$c) = @_;
    	    eval q( &copyout(($a), ($b), ($c)));
	}' unless defined(&IWCOPY);
	eval 'sub FREE_MB_T {
	    local($m) = @_;
    	    eval q( &freemsg($m));
	}' unless defined(&FREE_MB_T);
	eval 'sub SPL_NET {
	    local($x) = @_;
    	    eval q(;);
	}' unless defined(&SPL_NET);
	eval 'sub SPL_IMP {
	    local($x) = @_;
    	    eval q(;);
	}' unless defined(&SPL_IMP);
	undef(&SPL_X) if defined(&SPL_X);
	eval 'sub SPL_X {
	    local($x) = @_;
    	    eval q(;);
	}' unless defined(&SPL_X);
	if(defined(&sparc)) {
	    eval 'sub ntohs {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&ntohs);
	    eval 'sub ntohl {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&ntohl);
	    eval 'sub htons {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&htons);
	    eval 'sub htonl {
	        local($x) = @_;
    		eval q(($x));
	    }' unless defined(&htonl);
	}
	eval 'sub KMALLOC {
	    local($a,$b,$c) = @_;
    	    eval q( =  &kmem_alloc(($c),  &KM_NOSLEEP));
	}' unless defined(&KMALLOC);
	eval 'sub GET_MINOR {
	    local($x) = @_;
    	    eval q( &getminor($x));
	}' unless defined(&GET_MINOR);
	eval 'sub GETUNIT {
	    local($n) = @_;
    	    eval q( &get_unit(($n)));
	}' unless defined(&GETUNIT);
    } else {
	if(defined( &__sgi)) {
	    require 'sys/ksynch.ph';
	    eval 'sub IPF_LOCK_PL () { &plhi;}' unless defined(&IPF_LOCK_PL);
	    require 'sys/sema.ph';
	    undef(&kmutex_t) if defined(&kmutex_t);
	    eval 'sub MUTEX_ENTER {
	        local($x) = @_;
    		eval q(($x)-> &pl =  &LOCK(($x)-> &l,  &IPF_LOCK_PL););
	    }' unless defined(&MUTEX_ENTER);
	    eval 'sub MUTEX_EXIT {
	        local($x) = @_;
    		eval q( &UNLOCK(($x)-> &l, ($x)-> &pl););
	    }' unless defined(&MUTEX_EXIT);
	} else {
	    eval 'sub MUTEX_ENTER {
	        local($x) = @_;
    		eval q(;);
	    }' unless defined(&MUTEX_ENTER);
	    eval 'sub MUTEX_EXIT {
	        local($x) = @_;
    		eval q(;);
	    }' unless defined(&MUTEX_EXIT);
	}
	unless(defined(&linux)) {
	    eval 'sub FREE_MB_T {
	        local($m) = @_;
    		eval q( &m_freem($m));
	    }' unless defined(&FREE_MB_T);
	    eval 'sub MTOD {
	        local($m,$t) = @_;
    		eval q( &mtod($m,$t));
	    }' unless defined(&MTOD);
	    eval 'sub IRCOPY {
	        local($a,$b,$c) = @_;
    		eval q( &bcopy(($a), ($b), ($c)));
	    }' unless defined(&IRCOPY);
	    eval 'sub IWCOPY {
	        local($a,$b,$c) = @_;
    		eval q( &bcopy(($a), ($b), ($c)));
	    }' unless defined(&IWCOPY);
	}
    }
    if(defined(&sun)) {
	if(!(defined(&SOLARIS) ? &SOLARIS : 0)) {
	    require 'sys/kmem_alloc.ph';
	    eval 'sub GETUNIT {
	        local($n) = @_;
    		eval q( &ifunit(($n),  &IFNAMSIZ));
	    }' unless defined(&GETUNIT);
	}
    } else {
	unless(defined(&linux)) {
	    eval 'sub GETUNIT {
	        local($n) = @_;
    		eval q( &ifunit(($n)));
	    }' unless defined(&GETUNIT);
	}
    }
    if(defined( &sun)  && !defined( &linux) || defined( &__sgi)) {
	eval 'sub UIOMOVE {
	    local($a,$b,$c,$d) = @_;
    	    eval q( &uiomove($a,$b,$c,$d));
	}' unless defined(&UIOMOVE);
	eval 'sub SLEEP {
	    local($id, $n) = @_;
    	    eval q( &sleep(($id),  &PZERO+1));
	}' unless defined(&SLEEP);
	eval 'sub WAKEUP {
	    local($id) = @_;
    	    eval q( &wakeup($id));
	}' unless defined(&WAKEUP);
	eval 'sub KFREE {
	    local($x) = @_;
    	    eval q( &kmem_free(($x), $sizeof{($x)}));
	}' unless defined(&KFREE);
	eval 'sub KFREES {
	    local($x,$s) = @_;
    	    eval q( &kmem_free(($x), ($s)));
	}' unless defined(&KFREES);
	if(!(defined(&SOLARIS) ? &SOLARIS : 0)) {
	}
	if(defined(&__sgi)) {
	    require 'sys/kmem.ph';
	    require 'sys/ddi.ph';
	    eval 'sub KMALLOC {
	        local($a,$b,$c) = @_;
    		eval q( =  &kmem_alloc(($c),  &KM_NOSLEEP));
	    }' unless defined(&KMALLOC);
	    eval 'sub GET_MINOR {
	        local($x) = @_;
    		eval q( &getminor($x));
	    }' unless defined(&GET_MINOR);
	} else {
	    if(!(defined(&SOLARIS) ? &SOLARIS : 0)) {
		eval 'sub KMALLOC {
		    local($a,$b,$c) = @_;
    		    eval q( =  &new_kmem_alloc(($c),  &KMEM_NOSLEEP));
		}' unless defined(&KMALLOC);
	    }
	}
    }
    unless(defined(&GET_MINOR)) {
	eval 'sub GET_MINOR {
	    local($x) = @_;
    	    eval q( &minor($x));
	}' unless defined(&GET_MINOR);
    }
    if(((defined(&BSD) ? &BSD : 0) >= 199306) || defined( &__FreeBSD__)) {
	require 'vm/vm.ph';
	if(!defined( &__FreeBSD__) || (defined ( &__FreeBSD__)  && (defined(&__FreeBSD__) ? &__FreeBSD__ : 0)>=3)) {
	    require 'vm/vm_extern.ph';
	    require 'sys/proc.ph';
	} else {
	    require 'vm/vm_kern.ph';
	}
	if(defined(&M_PFIL)) {
	    eval 'sub KMALLOC {
	        local($a, $b, $c) = @_;
    		eval q( &MALLOC(($a), $b, ($c),  &M_PFIL,  &M_NOWAIT));
	    }' unless defined(&KMALLOC);
	    eval 'sub KFREE {
	        local($x) = @_;
    		eval q( &FREE(($x),  &M_PFIL));
	    }' unless defined(&KFREE);
	    eval 'sub KFREES {
	        local($x,$s) = @_;
    		eval q( &FREE(($x),  &M_PFIL));
	    }' unless defined(&KFREES);
	} else {
	    eval 'sub KMALLOC {
	        local($a, $b, $c) = @_;
    		eval q( &MALLOC(($a), $b, ($c),  &M_TEMP,  &M_NOWAIT));
	    }' unless defined(&KMALLOC);
	    eval 'sub KFREE {
	        local($x) = @_;
    		eval q( &FREE(($x),  &M_TEMP));
	    }' unless defined(&KFREE);
	    eval 'sub KFREES {
	        local($x,$s) = @_;
    		eval q( &FREE(($x),  &M_TEMP));
	    }' unless defined(&KFREES);
	}
	eval 'sub UIOMOVE {
	    local($a,$b,$c,$d) = @_;
    	    eval q( &uiomove($a,$b,$d));
	}' unless defined(&UIOMOVE);
	eval 'sub SLEEP {
	    local($id, $n) = @_;
    	    eval q( &tsleep(($id),  &PPAUSE| &PCATCH, $n, 0));
	}' unless defined(&SLEEP);
	eval 'sub WAKEUP {
	    local($id) = @_;
    	    eval q( &wakeup($id));
	}' unless defined(&WAKEUP);
    }
    if(defined( &NetBSD)  && (defined(&NetBSD) ? &NetBSD : 0) <= 1991011 && (defined(&NetBSD) ? &NetBSD : 0) >= 199407) {
	eval 'sub SPL_NET {
	    local($x) = @_;
    	    eval q($x =  &splsoftnet());
	}' unless defined(&SPL_NET);
	eval 'sub SPL_X {
	    local($x) = @_;
    	    eval q(  &splx($x));
	}' unless defined(&SPL_X);
    } else {
	if(!(defined(&SOLARIS) ? &SOLARIS : 0)  && !defined( &linux)) {
	    eval 'sub SPL_IMP {
	        local($x) = @_;
    		eval q($x =  &splimp());
	    }' unless defined(&SPL_IMP);
	    eval 'sub SPL_NET {
	        local($x) = @_;
    		eval q($x =  &splnet());
	    }' unless defined(&SPL_NET);
	    eval 'sub SPL_X {
	        local($x) = @_;
    		eval q(  &splx($x));
	    }' unless defined(&SPL_X);
	}
    }
    eval 'sub PANIC {
        local($x,$y) = @_;
	    eval q( &if  &panic $y);
    }' unless defined(&PANIC);
} else {
    eval 'sub SLEEP {
        local($x,$y) = @_;
	    eval q(;);
    }' unless defined(&SLEEP);
    eval 'sub WAKEUP {
        local($x) = @_;
	    eval q(;);
    }' unless defined(&WAKEUP);
    eval 'sub PANIC {
        local($x,$y) = @_;
	    eval q(;);
    }' unless defined(&PANIC);
    eval 'sub MUTEX_ENTER {
        local($x) = @_;
	    eval q(;);
    }' unless defined(&MUTEX_ENTER);
    eval 'sub MUTEX_EXIT {
        local($x) = @_;
	    eval q(;);
    }' unless defined(&MUTEX_EXIT);
    eval 'sub SPL_NET {
        local($x) = @_;
	    eval q(;);
    }' unless defined(&SPL_NET);
    eval 'sub SPL_IMP {
        local($x) = @_;
	    eval q(;);
    }' unless defined(&SPL_IMP);
    undef(&SPL_X) if defined(&SPL_X);
    eval 'sub SPL_X {
        local($x) = @_;
	    eval q(;);
    }' unless defined(&SPL_X);
    eval 'sub KMALLOC {
        local($a,$b,$c) = @_;
	    eval q( =  &malloc($c));
    }' unless defined(&KMALLOC);
    eval 'sub KFREE {
        local($x) = @_;
	    eval q( &free($x));
    }' unless defined(&KFREE);
    eval 'sub KFREES {
        local($x,$s) = @_;
	    eval q( &free($x));
    }' unless defined(&KFREES);
    eval 'sub GETUNIT {
        local($x) = @_;
	    eval q( &get_unit($x));
    }' unless defined(&GETUNIT);
    eval 'sub IRCOPY {
        local($a,$b,$c) = @_;
	    eval q( &bcopy(($a), ($b), ($c)));
    }' unless defined(&IRCOPY);
    eval 'sub IWCOPY {
        local($a,$b,$c) = @_;
	    eval q( &bcopy(($a), ($b), ($c)));
    }' unless defined(&IWCOPY);
}
if((defined(&SOLARIS) ? &SOLARIS : 0)) {
} else {
    if(defined(&linux)) {
    } else {
    }
}
if(defined( &linux) || defined( &__sgi)) {
    unless(defined(&ICMP_MINLEN)) {
	eval 'sub ICMP_MINLEN () {8;}' unless defined(&ICMP_MINLEN);
    }
    unless(defined(&ICMP_UNREACH)) {
	eval 'sub ICMP_UNREACH () { &ICMP_DEST_UNREACH;}' unless defined(&ICMP_UNREACH);
    }
    unless(defined(&ICMP_SOURCEQUENCH)) {
	eval 'sub ICMP_SOURCEQUENCH () { &ICMP_SOURCE_QUENCH;}' unless defined(&ICMP_SOURCEQUENCH);
    }
    unless(defined(&ICMP_TIMXCEED)) {
	eval 'sub ICMP_TIMXCEED () { &ICMP_TIME_EXCEEDED;}' unless defined(&ICMP_TIMXCEED);
    }
    unless(defined(&ICMP_PARAMPROB)) {
	eval 'sub ICMP_PARAMPROB () { &ICMP_PARAMETERPROB;}' unless defined(&ICMP_PARAMPROB);
    }
    unless(defined(&ICMP_TSTAMP)) {
	eval 'sub ICMP_TSTAMP () { &ICMP_TIMESTAMP;}' unless defined(&ICMP_TSTAMP);
    }
    unless(defined(&ICMP_TSTAMPREPLY)) {
	eval 'sub ICMP_TSTAMPREPLY () { &ICMP_TIMESTAMPREPLY;}' unless defined(&ICMP_TSTAMPREPLY);
    }
    unless(defined(&ICMP_IREQ)) {
	eval 'sub ICMP_IREQ () { &ICMP_INFO_REQUEST;}' unless defined(&ICMP_IREQ);
    }
    unless(defined(&ICMP_IREQREPLY)) {
	eval 'sub ICMP_IREQREPLY () { &ICMP_INFO_REPLY;}' unless defined(&ICMP_IREQREPLY);
    }
    unless(defined(&ICMP_MASKREQ)) {
	eval 'sub ICMP_MASKREQ () { &ICMP_ADDRESS;}' unless defined(&ICMP_MASKREQ);
    }
    unless(defined(&ICMP_MASKREPLY)) {
	eval 'sub ICMP_MASKREPLY () { &ICMP_ADDRESSREPLY;}' unless defined(&ICMP_MASKREPLY);
    }
    unless(defined(&IPVERSION)) {
	eval 'sub IPVERSION () {4;}' unless defined(&IPVERSION);
    }
    unless(defined(&IPOPT_MINOFF)) {
	eval 'sub IPOPT_MINOFF () {4;}' unless defined(&IPOPT_MINOFF);
    }
    unless(defined(&IPOPT_COPIED)) {
	eval 'sub IPOPT_COPIED {
	    local($x) = @_;
    	    eval q((($x)&0x80));
	}' unless defined(&IPOPT_COPIED);
    }
    unless(defined(&IPOPT_EOL)) {
	eval 'sub IPOPT_EOL () {0;}' unless defined(&IPOPT_EOL);
    }
    unless(defined(&IPOPT_NOP)) {
	eval 'sub IPOPT_NOP () {1;}' unless defined(&IPOPT_NOP);
    }
    unless(defined(&IP_MF)) {
	eval 'sub IP_MF () {(0x2000);}' unless defined(&IP_MF);
    }
    unless(defined(&ETHERTYPE_IP)) {
	eval 'sub ETHERTYPE_IP () {(0x0800);}' unless defined(&ETHERTYPE_IP);
    }
    unless(defined(&TH_FIN)) {
	eval 'sub TH_FIN () {0x01;}' unless defined(&TH_FIN);
    }
    unless(defined(&TH_SYN)) {
	eval 'sub TH_SYN () {0x02;}' unless defined(&TH_SYN);
    }
    unless(defined(&TH_RST)) {
	eval 'sub TH_RST () {0x04;}' unless defined(&TH_RST);
    }
    unless(defined(&TH_PUSH)) {
	eval 'sub TH_PUSH () {0x08;}' unless defined(&TH_PUSH);
    }
    unless(defined(&TH_ACK)) {
	eval 'sub TH_ACK () {0x10;}' unless defined(&TH_ACK);
    }
    unless(defined(&TH_URG)) {
	eval 'sub TH_URG () {0x20;}' unless defined(&TH_URG);
    }
    unless(defined(&IPOPT_EOL)) {
	eval 'sub IPOPT_EOL () {0;}' unless defined(&IPOPT_EOL);
    }
    unless(defined(&IPOPT_NOP)) {
	eval 'sub IPOPT_NOP () {1;}' unless defined(&IPOPT_NOP);
    }
    unless(defined(&IPOPT_RR)) {
	eval 'sub IPOPT_RR () {7;}' unless defined(&IPOPT_RR);
    }
    unless(defined(&IPOPT_TS)) {
	eval 'sub IPOPT_TS () {68;}' unless defined(&IPOPT_TS);
    }
    unless(defined(&IPOPT_SECURITY)) {
	eval 'sub IPOPT_SECURITY () {130;}' unless defined(&IPOPT_SECURITY);
    }
    unless(defined(&IPOPT_LSRR)) {
	eval 'sub IPOPT_LSRR () {131;}' unless defined(&IPOPT_LSRR);
    }
    unless(defined(&IPOPT_SATID)) {
	eval 'sub IPOPT_SATID () {136;}' unless defined(&IPOPT_SATID);
    }
    unless(defined(&IPOPT_SSRR)) {
	eval 'sub IPOPT_SSRR () {137;}' unless defined(&IPOPT_SSRR);
    }
    unless(defined(&IPOPT_SECUR_UNCLASS)) {
	eval 'sub IPOPT_SECUR_UNCLASS () {(0x0000);}' unless defined(&IPOPT_SECUR_UNCLASS);
    }
    unless(defined(&IPOPT_SECUR_CONFID)) {
	eval 'sub IPOPT_SECUR_CONFID () {(0xf135);}' unless defined(&IPOPT_SECUR_CONFID);
    }
    unless(defined(&IPOPT_SECUR_EFTO)) {
	eval 'sub IPOPT_SECUR_EFTO () {(0x789a);}' unless defined(&IPOPT_SECUR_EFTO);
    }
    unless(defined(&IPOPT_SECUR_MMMM)) {
	eval 'sub IPOPT_SECUR_MMMM () {(0xbc4d);}' unless defined(&IPOPT_SECUR_MMMM);
    }
    unless(defined(&IPOPT_SECUR_RESTR)) {
	eval 'sub IPOPT_SECUR_RESTR () {(0xaf13);}' unless defined(&IPOPT_SECUR_RESTR);
    }
    unless(defined(&IPOPT_SECUR_SECRET)) {
	eval 'sub IPOPT_SECUR_SECRET () {(0xd788);}' unless defined(&IPOPT_SECUR_SECRET);
    }
    unless(defined(&IPOPT_SECUR_TOPSECRET)) {
	eval 'sub IPOPT_SECUR_TOPSECRET () {(0x6bc5);}' unless defined(&IPOPT_SECUR_TOPSECRET);
    }
    unless(defined(&IPOPT_OLEN)) {
	eval 'sub IPOPT_OLEN () {1;}' unless defined(&IPOPT_OLEN);
    }
}
if(defined(&linux)) {
    eval 'sub TCPS_CLOSED () {0;}' unless defined(&TCPS_CLOSED);
    eval 'sub TCPS_LISTEN () {1;}' unless defined(&TCPS_LISTEN);
    eval 'sub TCPS_SYN_SENT () {2;}' unless defined(&TCPS_SYN_SENT);
    eval 'sub TCPS_SYN_RECEIVED () {3;}' unless defined(&TCPS_SYN_RECEIVED);
    eval 'sub TCPS_ESTABLISHED () {4;}' unless defined(&TCPS_ESTABLISHED);
    eval 'sub TCPS_CLOSE_WAIT () {5;}' unless defined(&TCPS_CLOSE_WAIT);
    eval 'sub TCPS_FIN_WAIT_1 () {6;}' unless defined(&TCPS_FIN_WAIT_1);
    eval 'sub TCPS_CLOSING () {7;}' unless defined(&TCPS_CLOSING);
    eval 'sub TCPS_LAST_ACK () {8;}' unless defined(&TCPS_LAST_ACK);
    eval 'sub TCPS_FIN_WAIT_2 () {9;}' unless defined(&TCPS_FIN_WAIT_2);
    eval 'sub TCPS_TIME_WAIT () {10;}' unless defined(&TCPS_TIME_WAIT);
    eval 'sub FWRITE () { &WRITE;}' unless defined(&FWRITE);
    eval 'sub FREAD () { &READ;}' unless defined(&FREAD);
    eval 'sub mtod {
        local($m,$t) = @_;
	    eval q((($m)-> &data));
    }' unless defined(&mtod);
    eval 'sub m_len () { &len;}' unless defined(&m_len);
    eval 'sub m_next () { &next;}' unless defined(&m_next);
    eval 'sub IP_DF () {0x8000;}' unless defined(&IP_DF);
    if(defined( &__i386__) || defined( &__MIPSEL__) || defined( &__alpha__) || defined( &vax)) {
    } else {
    }
    if(defined( &__i386__) || defined( &__MIPSEL__) || defined( &__alpha__) || defined( &vax)) {
    } else {
    }
    eval 'sub icmp_pptr () { ($icmp_hun->{ih_pptr});}' unless defined(&icmp_pptr);
    eval 'sub icmp_gwaddr () { ($icmp_hun->{ih_gwaddr});}' unless defined(&icmp_gwaddr);
    eval 'sub icmp_id () { ($icmp_hun->{ih_idseq}->{icd_id});}' unless defined(&icmp_id);
    eval 'sub icmp_seq () { ($icmp_hun->{ih_idseq}->{icd_seq});}' unless defined(&icmp_seq);
    eval 'sub icmp_void () { ($icmp_hun->{ih_void});}' unless defined(&icmp_void);
    eval 'sub icmp_otime () { ($icmp_dun->{id_ts}->{its_otime});}' unless defined(&icmp_otime);
    eval 'sub icmp_rtime () { ($icmp_dun->{id_ts}->{its_rtime});}' unless defined(&icmp_rtime);
    eval 'sub icmp_ttime () { ($icmp_dun->{id_ts}->{its_ttime});}' unless defined(&icmp_ttime);
    eval 'sub icmp_ip () { ($icmp_dun->{id_ip}->{idi_ip});}' unless defined(&icmp_ip);
    eval 'sub icmp_mask () { ($icmp_dun->{id_mask});}' unless defined(&icmp_mask);
    eval 'sub icmp_data () { ($icmp_dun->{id_data});}' unless defined(&icmp_data);
    unless(defined(&LINUX_IPOVLY)) {
	eval 'sub LINUX_IPOVLY () {1;}' unless defined(&LINUX_IPOVLY);
    }
    eval 'sub UIO_READ () {0;}' unless defined(&UIO_READ);
    eval 'sub UIO_WRITE () {1;}' unless defined(&UIO_WRITE);
    eval 'sub UIOMOVE {
        local($a, $b, $c, $d) = @_;
	    eval q( &uiomove($a,$b,$c,$d));
    }' unless defined(&UIOMOVE);
    eval 'sub if_name () { &name;}' unless defined(&if_name);
    if(defined(&KERNEL)) {
	eval 'sub GETUNIT {
	    local($x) = @_;
    	    eval q( &dev_get($x));
	}' unless defined(&GETUNIT);
	eval 'sub FREE_MB_T {
	    local($m) = @_;
    	    eval q( &kfree_skb($m,  &FREE_WRITE));
	}' unless defined(&FREE_MB_T);
	eval 'sub uniqtime () { &do_gettimeofday;}' unless defined(&uniqtime);
	undef(&INT_MAX) if defined(&INT_MAX);
	undef(&UINT_MAX) if defined(&UINT_MAX);
	undef(&LONG_MAX) if defined(&LONG_MAX);
	undef(&ULONG_MAX) if defined(&ULONG_MAX);
	require 'linux/netdevice.ph';
	eval 'sub SPL_X {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&SPL_X);
	eval 'sub SPL_NET {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&SPL_NET);
	eval 'sub SPL_IMP {
	    local($x) = @_;
    	    eval q();
	}' unless defined(&SPL_IMP);
	eval 'sub bcmp {
	    local($a,$b,$c) = @_;
    	    eval q( &memcmp($a,$b,$c));
	}' unless defined(&bcmp);
	eval 'sub bcopy {
	    local($a,$b,$c) = @_;
    	    eval q( &memcpy($b,$a,$c));
	}' unless defined(&bcopy);
	eval 'sub bzero {
	    local($a,$c) = @_;
    	    eval q( &memset($a,0,$c));
	}' unless defined(&bzero);
	eval 'sub UNITNAME {
	    local($n) = @_;
    	    eval q( &dev_get(($n)));
	}' unless defined(&UNITNAME);
	eval 'sub KMALLOC {
	    local($a,$b,$c) = @_;
    	    eval q( =  &kmalloc(($c),  &GFP_ATOMIC));
	}' unless defined(&KMALLOC);
	eval 'sub KFREE {
	    local($x) = @_;
    	    eval q( &kfree_s(($x), $sizeof{($x)}));
	}' unless defined(&KFREE);
	eval 'sub KFREES {
	    local($x,$s) = @_;
    	    eval q( &kfree_s(($x), ($s)));
	}' unless defined(&KFREES);
	eval 'sub IRCOPY {
	    local($a,$b,$c) = @_;
    	    eval q({  &error =  &verify_area( &VERIFY_READ, ($a) ,($c));  &if (! &error)  &memcpy_fromfs(($b), ($a), ($c)); });
	}' unless defined(&IRCOPY);
	eval 'sub IWCOPY {
	    local($a,$b,$c) = @_;
    	    eval q({  &error =  &verify_area( &VERIFY_WRITE, ($b), ($c));  &if (! &error)  &memcpy_tofs(($b), ($a), ($c)); });
	}' unless defined(&IWCOPY);
    } else {
	eval 'sub __KERNEL__ () {1;}' unless defined(&__KERNEL__);
	undef(&INT_MAX) if defined(&INT_MAX);
	undef(&UINT_MAX) if defined(&UINT_MAX);
	undef(&LONG_MAX) if defined(&LONG_MAX);
	undef(&ULONG_MAX) if defined(&ULONG_MAX);
	eval 'sub s8 () { &__s8;}' unless defined(&s8);
	eval 'sub u8 () { &__u8;}' unless defined(&u8);
	eval 'sub s16 () { &__s16;}' unless defined(&s16);
	eval 'sub u16 () { &__u16;}' unless defined(&u16);
	eval 'sub s32 () { &__s32;}' unless defined(&s32);
	eval 'sub u32 () { &__u32;}' unless defined(&u32);
	require 'linux/netdevice.ph';
	undef(&__KERNEL__) if defined(&__KERNEL__);
    }
    eval 'sub ifnet () { &device;}' unless defined(&ifnet);
} else {
}
if(defined( &hpux) || defined( &linux)) {
}
if(defined(&ultrix)) {
    eval 'sub A_A () {1;}' unless defined(&A_A);
} else {
    eval 'sub A_A () {&;}' unless defined(&A_A);
}
unless(defined(&ICMP_ROUTERADVERT)) {
    eval 'sub ICMP_ROUTERADVERT () {9;}' unless defined(&ICMP_ROUTERADVERT);
}
unless(defined(&ICMP_ROUTERSOLICIT)) {
    eval 'sub ICMP_ROUTERSOLICIT () {10;}' unless defined(&ICMP_ROUTERSOLICIT);
}
    }
1;
