require '_h2ph_pre.ph';

unless(defined(&CIS_NULL)) {
    sub CIS_NULL () {	0;}
}
unless(defined(&CIS_MEM_COMMON)) {
    sub CIS_MEM_COMMON () {	0x01;}
}
unless(defined(&CIS_CHECKSUM)) {
    sub CIS_CHECKSUM () {	0x10;}
}
unless(defined(&CIS_LONGLINK_A)) {
    sub CIS_LONGLINK_A () {	0x11;}
}
unless(defined(&CIS_LONGLINK_C)) {
    sub CIS_LONGLINK_C () {	0x12;}
}
unless(defined(&CIS_LINKTARGET)) {
    sub CIS_LINKTARGET () {	0x13;}
}
unless(defined(&CIS_NOLINK)) {
    sub CIS_NOLINK () {	0x14;}
}
unless(defined(&CIS_INFO_V1)) {
    sub CIS_INFO_V1 () {	0x15;}
}
unless(defined(&CIS_ALTSTR)) {
    sub CIS_ALTSTR () {	0x16;}
}
unless(defined(&CIS_MEM_ATTR)) {
    sub CIS_MEM_ATTR () {	0x17;}
}
unless(defined(&CIS_JEDEC_C)) {
    sub CIS_JEDEC_C () {	0x18;}
}
unless(defined(&CIS_JEDEC_A)) {
    sub CIS_JEDEC_A () {	0x19;}
}
unless(defined(&CIS_CONF_MAP)) {
    sub CIS_CONF_MAP () {	0x1a;}
}
unless(defined(&CIS_CONFIG)) {
    sub CIS_CONFIG () {	0x1b;}
}
unless(defined(&CIS_DEVICE_OC)) {
    sub CIS_DEVICE_OC () {	0x1c;}
}
unless(defined(&CIS_DEVICE_OA)) {
    sub CIS_DEVICE_OA () {	0x1d;}
}
unless(defined(&CIS_DEVICEGEO)) {
    sub CIS_DEVICEGEO () {	0x1e;}
}
unless(defined(&CIS_DEVICEGEO_A)) {
    sub CIS_DEVICEGEO_A () {	0x1f;}
}
unless(defined(&CIS_MANUF_ID)) {
    sub CIS_MANUF_ID () {	0x20;}
}
unless(defined(&CIS_FUNC_ID)) {
    sub CIS_FUNC_ID () {	0x21;}
}
unless(defined(&CIS_FUNC_EXT)) {
    sub CIS_FUNC_EXT () {	0x22;}
}
unless(defined(&CIS_SW_INTERLV)) {
    sub CIS_SW_INTERLV () {	0x23;}
}
unless(defined(&CIS_VERS_2)) {
    sub CIS_VERS_2 () {	0x40;}
}
unless(defined(&CIS_FORMAT)) {
    sub CIS_FORMAT () {	0x41;}
}
unless(defined(&CIS_GEOMETRY)) {
    sub CIS_GEOMETRY () {	0x42;}
}
unless(defined(&CIS_BYTEORDER)) {
    sub CIS_BYTEORDER () {	0x43;}
}
unless(defined(&CIS_DATE)) {
    sub CIS_DATE () {	0x44;}
}
unless(defined(&CIS_BATTERY)) {
    sub CIS_BATTERY () {	0x45;}
}
unless(defined(&CIS_ORG)) {
    sub CIS_ORG () {	0x46;}
}
unless(defined(&CIS_END)) {
    sub CIS_END () {	0xff;}
}
unless(defined(&CIS_MAJOR_VERSION)) {
    sub CIS_MAJOR_VERSION () {	4;}
}
unless(defined(&CIS_MINOR_VERSION)) {
    sub CIS_MINOR_VERSION () {	1;}
}
unless(defined(&CIS_FEAT_POWER)) {
    sub CIS_FEAT_POWER {
	local($x) = @_;
	eval q((($x) & 0x3));
    }
}
unless(defined(&CIS_FEAT_TIMING)) {
    sub CIS_FEAT_TIMING () {	0x4;}
}
unless(defined(&CIS_FEAT_I_O)) {
    sub CIS_FEAT_I_O () {	0x8;}
}
unless(defined(&CIS_FEAT_IRQ)) {
    sub CIS_FEAT_IRQ () {	0x10;}
}
unless(defined(&CIS_FEAT_MEMORY)) {
    sub CIS_FEAT_MEMORY {
	local($x) = @_;
	eval q(((($x) >> 5) & 0x3));
    }
}
unless(defined(&CIS_FEAT_MISC)) {
    sub CIS_FEAT_MISC () {	0x80;}
}
unless(defined(&CIS_WAIT_SCALE)) {
    sub CIS_WAIT_SCALE {
	local($x) = @_;
	eval q((($x) & 0x3));
    }
}
unless(defined(&CIS_READY_SCALE)) {
    sub CIS_READY_SCALE {
	local($x) = @_;
	eval q(((($x)>>2) & 0x7));
    }
}
unless(defined(&CIS_RESERVED_SCALE)) {
    sub CIS_RESERVED_SCALE {
	local($x) = @_;
	eval q(((($x)>>5) & 0x7));
    }
}
unless(defined(&CIS_IO_ADDR)) {
    sub CIS_IO_ADDR {
	local($x) = @_;
	eval q((($x) & 0x1f));
    }
}
unless(defined(&CIS_IO_8BIT)) {
    sub CIS_IO_8BIT () {	0x20;}
}
unless(defined(&CIS_IO_16BIT)) {
    sub CIS_IO_16BIT () {	0x40;}
}
unless(defined(&CIS_IO_RANGE)) {
    sub CIS_IO_RANGE () {	0x80;}
}
unless(defined(&CIS_IO_BLKS)) {
    sub CIS_IO_BLKS {
	local($x) = @_;
	eval q((($x) & 0xf));
    }
}
unless(defined(&CIS_IO_ADSZ)) {
    sub CIS_IO_ADSZ {
	local($x) = @_;
	eval q(((($x)>>4) & 3));
    }
}
unless(defined(&CIS_IO_BLKSZ)) {
    sub CIS_IO_BLKSZ {
	local($x) = @_;
	eval q(((($x)>>6) & 3));
    }
}
unless(defined(&CIS_IRQ_IRQN)) {
    sub CIS_IRQ_IRQN {
	local($x) = @_;
	eval q((($x) & 0xf));
    }
}
unless(defined(&CIS_IRQ_MASK)) {
    sub CIS_IRQ_MASK () {	0x10;}
}
unless(defined(&CIS_IRQ_LEVEL)) {
    sub CIS_IRQ_LEVEL () {	0x20;}
}
unless(defined(&CIS_IRQ_PULSE)) {
    sub CIS_IRQ_PULSE () {	0x40;}
}
unless(defined(&CIS_IRQ_SHARING)) {
    sub CIS_IRQ_SHARING () {	0x80;}
}
unless(defined(&CIS_FEAT_MEM_NONE)) {
    sub CIS_FEAT_MEM_NONE () {	0;}
}
unless(defined(&CIS_FEAT_MEM_LEN)) {
    sub CIS_FEAT_MEM_LEN () {	1;}
}
unless(defined(&CIS_FEAT_MEM_ADDR)) {
    sub CIS_FEAT_MEM_ADDR () {	2;}
}
unless(defined(&CIS_FEAT_MEM_WIN)) {
    sub CIS_FEAT_MEM_WIN () {	3;}
}
unless(defined(&CIS_MEM_WINS)) {
    sub CIS_MEM_WINS {
	local($x) = @_;
	eval q(((($x) & 0x7)+1));
    }
}
unless(defined(&CIS_MEM_LENSZ)) {
    sub CIS_MEM_LENSZ {
	local($x) = @_;
	eval q(((($x) >> 3) & 0x3));
    }
}
unless(defined(&CIS_MEM_ADDRSZ)) {
    sub CIS_MEM_ADDRSZ {
	local($x) = @_;
	eval q(((($x) >> 5) & 0x3));
    }
}
unless(defined(&CIS_MEM_HOST)) {
    sub CIS_MEM_HOST () {	0x80;}
}
1;
