require '_h2ph_pre.ph';

unless(defined(&_SYS_MALLOC_H_)) {
    eval 'sub _SYS_MALLOC_H_ () {1;}' unless defined(&_SYS_MALLOC_H_);
    eval 'sub splmem () { &splhigh;}' unless defined(&splmem);
    eval 'sub KMEMSTATS () {1;}' unless defined(&KMEMSTATS);
    eval 'sub M_WAITOK () {0x0000;}' unless defined(&M_WAITOK);
    eval 'sub M_NOWAIT () {0x0001;}' unless defined(&M_NOWAIT);
    eval 'sub M_KERNEL () {0x0002;}' unless defined(&M_KERNEL);
    eval 'sub M_MAGIC () {877983977;}' unless defined(&M_MAGIC);
    if(defined(&KERNEL)) {
	eval 'sub MALLOC_DEFINE {
	    local($type, $shortdesc, $longdesc) = @_;
    	    eval q(\'struct malloc_type\' $type->[1] = { {  &NULL, 0, 0, 0, 0, 0, 0,  &M_MAGIC, $shortdesc, 0, 0} };  &SYSINIT($type &_init,  &SI_SUB_KMEM,  &SI_ORDER_ANY,  &malloc_init, $type);  &SYSUNINIT($type &_uninit,  &SI_SUB_KMEM,  &SI_ORDER_ANY,  &malloc_uninit, $type));
	}' unless defined(&MALLOC_DEFINE);
	eval 'sub MALLOC_DECLARE {
	    local($type) = @_;
    	    eval q( &extern \'struct malloc_type\' $type->[1]);
	}' unless defined(&MALLOC_DECLARE);
	if(defined(&MALLOC_INSTANTIATE)) {
	    eval 'sub MALLOC_MAKE_TYPE {
	        local($type, $shortdesc, $longdesc) = @_;
    		eval q( &MALLOC_DEFINE($type, $shortdesc, $longdesc));
	    }' unless defined(&MALLOC_MAKE_TYPE);
	} else {
	    eval 'sub MALLOC_MAKE_TYPE {
	        local($type, $shortdesc, $longdesc) = @_;
    		eval q( &MALLOC_DECLARE($type));
	    }' unless defined(&MALLOC_MAKE_TYPE);
	}
    }
    eval 'sub ku_freecnt () { ($ku_un->{freecnt});}' unless defined(&ku_freecnt);
    eval 'sub ku_pagecnt () { ($ku_un->{pagecnt});}' unless defined(&ku_pagecnt);
    if(defined(&KERNEL)) {
	eval 'sub MINALLOCSIZE () {(1<<  &MINBUCKET);}' unless defined(&MINALLOCSIZE);
	eval 'sub BUCKETINDX {
	    local($size) = @_;
    	    eval q((($size) <= ( &MINALLOCSIZE * 128) ? ($size) <= ( &MINALLOCSIZE * 8) ? ($size) <= ( &MINALLOCSIZE * 2) ? ($size) <= ( &MINALLOCSIZE * 1) ? ( &MINBUCKET + 0) : ( &MINBUCKET + 1) : ($size) <= ( &MINALLOCSIZE * 4) ? ( &MINBUCKET + 2) : ( &MINBUCKET + 3) : ($size) <= ( &MINALLOCSIZE* 32) ? ($size) <= ( &MINALLOCSIZE * 16) ? ( &MINBUCKET + 4) : ( &MINBUCKET + 5) : ($size) <= ( &MINALLOCSIZE * 64) ? ( &MINBUCKET + 6) : ( &MINBUCKET + 7) : ($size) <= ( &MINALLOCSIZE * 2048) ? ($size) <= ( &MINALLOCSIZE * 512) ? ($size) <= ( &MINALLOCSIZE * 256) ? ( &MINBUCKET + 8) : ( &MINBUCKET + 9) : ($size) <= ( &MINALLOCSIZE * 1024) ? ( &MINBUCKET + 10) : ( &MINBUCKET + 11) : ($size) <= ( &MINALLOCSIZE * 8192) ? ($size) <= ( &MINALLOCSIZE * 4096) ? ( &MINBUCKET + 12) : ( &MINBUCKET + 13) : ($size) <= ( &MINALLOCSIZE * 16384) ? ( &MINBUCKET + 14) : ( &MINBUCKET + 15)));
	}' unless defined(&BUCKETINDX);
	eval 'sub kmemxtob {
	    local($alloc) = @_;
    	    eval q(( &kmembase + ($alloc) *  &PAGE_SIZE));
	}' unless defined(&kmemxtob);
	eval 'sub btokmemx {
	    local($addr) = @_;
    	    eval q(((($addr) -  &kmembase) /  &PAGE_SIZE));
	}' unless defined(&btokmemx);
	eval 'sub btokup {
	    local($addr) = @_;
    	    eval q(( $kmemusage[($addr) -  &kmembase >>  &PAGE_SHIFT]));
	}' unless defined(&btokup);
	if(defined( &KMEMSTATS) || defined( &DIAGNOSTIC)) {
	    eval 'sub MALLOC {
	        local($space, $cast, $size, $type, $flags) = @_;
    		eval q( =  &malloc(($size), $type, $flags));
	    }' unless defined(&MALLOC);
	    eval 'sub FREE {
	        local($addr, $type) = @_;
    		eval q( &free(($addr), $type));
	    }' unless defined(&FREE);
	} else {
	    eval 'sub MALLOC {
	        local($space, $cast, $size, $type, $flags) = @_;
    		eval q( &do {  &register \'struct kmembuckets\' * &kbp =  $bucket[ &BUCKETINDX]; \'long s\' =  &splmem();  &if ( ($kbp->{kb_next}) ==  &NULL) { =  &malloc(, $type, $flags); }  &else { =  ($kbp->{kb_next});  ($kbp->{kb_next}) = *($space); }  &splx( &s); }  &while (0));
	    }' unless defined(&MALLOC);
	    eval 'sub FREE {
	        local($addr, $type) = @_;
    		eval q( &do {  &register \'struct kmembuckets\' * &kbp;  &register \'struct kmemusage\' * &kup =  &btokup; \'long s\' =  &splmem();  &if (1<<  ($kup->{ku_indx}) >  &MAXALLOCSAVE) {  &free(, $type); }  &else {  &kbp =  $bucket[ ($kup->{ku_indx})];  &if ( ($kbp->{kb_next}) ==  &NULL)  ($kbp->{kb_next}) = ;  &else *( ($kbp->{kb_last})) = ; * =  &NULL;  ($kbp->{kb_last}) = ($addr); }  &splx( &s); }  &while (0));
	    }' unless defined(&FREE);
	}
    }
}
1;
